# coding: utf-8

"""
    Nomad Envoy

    This is the API descriptor for the Nomad Envoy API, responsible for order operation and product lists. Developed by [Samarkand Global](https://samarkand.global) in partnership with [Youzan](https://www.youzan.com/), [LittleRED](https://www.xiaohongshu.com/), [PDD](http://www.pinduoduo.com/), etc. Read the documentation online at [Nomad API Suite](https://api.samarkand.io/). - Install for node with `npm install nomad_envoy_cli` - Install for python with `pip install nomad-envoy-cli`  # noqa: E501

    The version of the OpenAPI document: 1.57.0
    Contact: paul@samarkand.global
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from nomad_envoy_cli.configuration import Configuration


class Inventory(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'product_id': 'str',
        'batch_id': 'str',
        'location_id': 'str',
        'sku_name': 'str',
        'barcode': 'str',
        'quantity': 'int'
    }

    attribute_map = {
        'product_id': 'product_id',
        'batch_id': 'batch_id',
        'location_id': 'location_id',
        'sku_name': 'sku_name',
        'barcode': 'barcode',
        'quantity': 'quantity'
    }

    def __init__(self, product_id=None, batch_id=None, location_id=None, sku_name=None, barcode=None, quantity=None, local_vars_configuration=None):  # noqa: E501
        """Inventory - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._product_id = None
        self._batch_id = None
        self._location_id = None
        self._sku_name = None
        self._barcode = None
        self._quantity = None
        self.discriminator = None

        self.product_id = product_id
        if batch_id is not None:
            self.batch_id = batch_id
        if location_id is not None:
            self.location_id = location_id
        if sku_name is not None:
            self.sku_name = sku_name
        if barcode is not None:
            self.barcode = barcode
        self.quantity = quantity

    @property
    def product_id(self):
        """Gets the product_id of this Inventory.  # noqa: E501

        ID of the product in the store's inventory.  # noqa: E501

        :return: The product_id of this Inventory.  # noqa: E501
        :rtype: str
        """
        return self._product_id

    @product_id.setter
    def product_id(self, product_id):
        """Sets the product_id of this Inventory.

        ID of the product in the store's inventory.  # noqa: E501

        :param product_id: The product_id of this Inventory.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and product_id is None:  # noqa: E501
            raise ValueError("Invalid value for `product_id`, must not be `None`")  # noqa: E501

        self._product_id = product_id

    @property
    def batch_id(self):
        """Gets the batch_id of this Inventory.  # noqa: E501

        ID of the product batch in the store's inventory.  # noqa: E501

        :return: The batch_id of this Inventory.  # noqa: E501
        :rtype: str
        """
        return self._batch_id

    @batch_id.setter
    def batch_id(self, batch_id):
        """Sets the batch_id of this Inventory.

        ID of the product batch in the store's inventory.  # noqa: E501

        :param batch_id: The batch_id of this Inventory.  # noqa: E501
        :type: str
        """

        self._batch_id = batch_id

    @property
    def location_id(self):
        """Gets the location_id of this Inventory.  # noqa: E501

        ID of the product location in the store's inventory.  # noqa: E501

        :return: The location_id of this Inventory.  # noqa: E501
        :rtype: str
        """
        return self._location_id

    @location_id.setter
    def location_id(self, location_id):
        """Sets the location_id of this Inventory.

        ID of the product location in the store's inventory.  # noqa: E501

        :param location_id: The location_id of this Inventory.  # noqa: E501
        :type: str
        """

        self._location_id = location_id

    @property
    def sku_name(self):
        """Gets the sku_name of this Inventory.  # noqa: E501

        SKU name of product in the store's inventory.  # noqa: E501

        :return: The sku_name of this Inventory.  # noqa: E501
        :rtype: str
        """
        return self._sku_name

    @sku_name.setter
    def sku_name(self, sku_name):
        """Sets the sku_name of this Inventory.

        SKU name of product in the store's inventory.  # noqa: E501

        :param sku_name: The sku_name of this Inventory.  # noqa: E501
        :type: str
        """

        self._sku_name = sku_name

    @property
    def barcode(self):
        """Gets the barcode of this Inventory.  # noqa: E501

        Barcode of product in the store's inventory.  # noqa: E501

        :return: The barcode of this Inventory.  # noqa: E501
        :rtype: str
        """
        return self._barcode

    @barcode.setter
    def barcode(self, barcode):
        """Sets the barcode of this Inventory.

        Barcode of product in the store's inventory.  # noqa: E501

        :param barcode: The barcode of this Inventory.  # noqa: E501
        :type: str
        """

        self._barcode = barcode

    @property
    def quantity(self):
        """Gets the quantity of this Inventory.  # noqa: E501

        Quantity of product in the store's inventory.  # noqa: E501

        :return: The quantity of this Inventory.  # noqa: E501
        :rtype: int
        """
        return self._quantity

    @quantity.setter
    def quantity(self, quantity):
        """Sets the quantity of this Inventory.

        Quantity of product in the store's inventory.  # noqa: E501

        :param quantity: The quantity of this Inventory.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and quantity is None:  # noqa: E501
            raise ValueError("Invalid value for `quantity`, must not be `None`")  # noqa: E501

        self._quantity = quantity

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Inventory):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Inventory):
            return True

        return self.to_dict() != other.to_dict()
